/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_asm.inc 372 2009-09-10 01:58:34Z ertl-honda $
 */

#ifndef TOPPERS_PRC_ASM_INC
#define TOPPERS_PRC_ASM_INC

#define PRC_ID_ADDR_ASM 0xFFFFFFE0

.macro my_core_index re_reg
	rdctl \re_reg, cpuid
.endm

.macro my_pcb re_reg sc_reg1
	rdctl \sc_reg1, cpuid
	slli  \sc_reg1, \sc_reg1, 2
	movhi \re_reg, %hiadj(p_pcb_table)
	addi  \re_reg, \re_reg, %lo(p_pcb_table)
	add   \sc_reg1, \sc_reg1, \re_reg
	ldw   \re_reg, 0(\sc_reg1)
.endm

.macro my_istkpt re_reg sc_reg1
	rdctl \sc_reg1, cpuid
	slli  \sc_reg1, \sc_reg1, 2
	movhi \re_reg, %hiadj(_kernel_istkpt_table)
	addi  \re_reg, \re_reg, %lo(_kernel_istkpt_table)
	add   \sc_reg1, \sc_reg1, \re_reg
	ldw   \re_reg, 0(\sc_reg1)
.endm

#endif /* TOPPERS_PRC_ASM_INC */
