/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_ipi.h 398 2009-09-15 15:32:17Z ertl-honda $
 */

/*
 *  ץåֳߥɥ饤
 */

#ifndef TOPPERS_TARGET_IPI_H
#define TOPPERS_TARGET_IPI_H

/*
 *  ץåֳߤγߥϥɥֹ
 */
#define INHNO_IPI1   (0x10000 | PRC_INT_INT)
#define INHNO_IPI2   (0x20000 | PRC_INT_INT)
#define INHNO_IPI3   (0x30000 | PRC_INT_INT)
#define INHNO_IPI4   (0x40000 | PRC_INT_INT)

/*
 *ץåֳߤγֹ
 */
#define INTNO_IPI1   (0x10000 | PRC_INT_INT)
#define INTNO_IPI2   (0x20000 | PRC_INT_INT)
#define INTNO_IPI3   (0x30000 | PRC_INT_INT)
#define INTNO_IPI4   (0x40000 | PRC_INT_INT)

/*
 *  ץåֳߤγͥ
 */
#define INTPRI_IPI1  (-3)
#define INTPRI_IPI2  (-3)
#define INTPRI_IPI3  (-3)
#define INTPRI_IPI4  (-3)

/*
 *  ץå¸⥸塼NIOS2ѡ
 */
#include "nios2_gcc/prc_ipi.h"

#endif /* TOPPERS_TARGET_IPI_H */
